/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { AccountResponse } from '../model/accountResponse';
import { AccountsResponse } from '../model/accountsResponse';
import { Configuration } from '../configuration';
export declare class AccountsService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Single account
     * Returns a single account
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param accountId The id of the account
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getAccountById(budgetId: string, accountId: string, observe?: 'body', reportProgress?: boolean): Observable<AccountResponse>;
    getAccountById(budgetId: string, accountId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<AccountResponse>>;
    getAccountById(budgetId: string, accountId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<AccountResponse>>;
    /**
     * Account list
     * Returns all accounts
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param lastKnowledgeOfServer The starting server knowledge.  If provided, only entities that have changed since last_knowledge_of_server will be included.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getAccounts(budgetId: string, lastKnowledgeOfServer?: number, observe?: 'body', reportProgress?: boolean): Observable<AccountsResponse>;
    getAccounts(budgetId: string, lastKnowledgeOfServer?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<AccountsResponse>>;
    getAccounts(budgetId: string, lastKnowledgeOfServer?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<AccountsResponse>>;
}
