/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { BudgetDetailResponse } from '../model/budgetDetailResponse';
import { BudgetSettingsResponse } from '../model/budgetSettingsResponse';
import { BudgetSummaryResponse } from '../model/budgetSummaryResponse';
import { Configuration } from '../configuration';
export declare class BudgetsService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Single budget
     * Returns a single budget with all related entities.  This resource is effectively a full budget export.
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param lastKnowledgeOfServer The starting server knowledge.  If provided, only entities that have changed since last_knowledge_of_server will be included.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getBudgetById(budgetId: string, lastKnowledgeOfServer?: number, observe?: 'body', reportProgress?: boolean): Observable<BudgetDetailResponse>;
    getBudgetById(budgetId: string, lastKnowledgeOfServer?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BudgetDetailResponse>>;
    getBudgetById(budgetId: string, lastKnowledgeOfServer?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BudgetDetailResponse>>;
    /**
     * Budget Settings
     * Returns settings for a budget
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getBudgetSettingsById(budgetId: string, observe?: 'body', reportProgress?: boolean): Observable<BudgetSettingsResponse>;
    getBudgetSettingsById(budgetId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BudgetSettingsResponse>>;
    getBudgetSettingsById(budgetId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BudgetSettingsResponse>>;
    /**
     * List budgets
     * Returns budgets list with summary information
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getBudgets(observe?: 'body', reportProgress?: boolean): Observable<BudgetSummaryResponse>;
    getBudgets(observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BudgetSummaryResponse>>;
    getBudgets(observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BudgetSummaryResponse>>;
}
