/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { BulkResponse } from '../model/bulkResponse';
import { BulkTransactions } from '../model/bulkTransactions';
import { Configuration } from '../configuration';
export declare class DeprecatedService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Bulk create transactions
     * Creates multiple transactions.  Although this endpoint is still supported, it is recommended to use \&#39;POST /budgets/{budget_id}/transactions\&#39; to create multiple transactions.
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param transactions The list of transactions to create
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    bulkCreateTransactions(budgetId: string, transactions: BulkTransactions, observe?: 'body', reportProgress?: boolean): Observable<BulkResponse>;
    bulkCreateTransactions(budgetId: string, transactions: BulkTransactions, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<BulkResponse>>;
    bulkCreateTransactions(budgetId: string, transactions: BulkTransactions, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<BulkResponse>>;
}
