/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { MonthDetailResponse } from '../model/monthDetailResponse';
import { MonthSummariesResponse } from '../model/monthSummariesResponse';
import { Configuration } from '../configuration';
export declare class MonthsService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Single budget month
     * Returns a single budget month
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param month The budget month in ISO format (e.g. 2016-12-01) (\&quot;current\&quot; can also be used to specify the current calendar month (UTC))
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getBudgetMonth(budgetId: string, month: string, observe?: 'body', reportProgress?: boolean): Observable<MonthDetailResponse>;
    getBudgetMonth(budgetId: string, month: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<MonthDetailResponse>>;
    getBudgetMonth(budgetId: string, month: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<MonthDetailResponse>>;
    /**
     * List budget months
     * Returns all budget months
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param lastKnowledgeOfServer The starting server knowledge.  If provided, only entities that have changed since last_knowledge_of_server will be included.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getBudgetMonths(budgetId: string, lastKnowledgeOfServer?: number, observe?: 'body', reportProgress?: boolean): Observable<MonthSummariesResponse>;
    getBudgetMonths(budgetId: string, lastKnowledgeOfServer?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<MonthSummariesResponse>>;
    getBudgetMonths(budgetId: string, lastKnowledgeOfServer?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<MonthSummariesResponse>>;
}
