/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { PayeeLocationResponse } from '../model/payeeLocationResponse';
import { PayeeLocationsResponse } from '../model/payeeLocationsResponse';
import { Configuration } from '../configuration';
export declare class PayeeLocationsService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Single payee location
     * Returns a single payee location
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param payeeLocationId id of payee location
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getPayeeLocationById(budgetId: string, payeeLocationId: string, observe?: 'body', reportProgress?: boolean): Observable<PayeeLocationResponse>;
    getPayeeLocationById(budgetId: string, payeeLocationId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PayeeLocationResponse>>;
    getPayeeLocationById(budgetId: string, payeeLocationId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PayeeLocationResponse>>;
    /**
     * List payee locations
     * Returns all payee locations
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getPayeeLocations(budgetId: string, observe?: 'body', reportProgress?: boolean): Observable<PayeeLocationsResponse>;
    getPayeeLocations(budgetId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PayeeLocationsResponse>>;
    getPayeeLocations(budgetId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PayeeLocationsResponse>>;
    /**
     * List locations for a payee
     * Returns all payee locations for the specified payee
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param payeeId id of payee
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getPayeeLocationsByPayee(budgetId: string, payeeId: string, observe?: 'body', reportProgress?: boolean): Observable<PayeeLocationsResponse>;
    getPayeeLocationsByPayee(budgetId: string, payeeId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<PayeeLocationsResponse>>;
    getPayeeLocationsByPayee(budgetId: string, payeeId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<PayeeLocationsResponse>>;
}
