/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { ScheduledTransactionResponse } from '../model/scheduledTransactionResponse';
import { ScheduledTransactionsResponse } from '../model/scheduledTransactionsResponse';
import { Configuration } from '../configuration';
export declare class ScheduledTransactionsService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Single scheduled transaction
     * Returns a single scheduled transaction
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param scheduledTransactionId The id of the scheduled transaction
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getScheduledTransactionById(budgetId: string, scheduledTransactionId: string, observe?: 'body', reportProgress?: boolean): Observable<ScheduledTransactionResponse>;
    getScheduledTransactionById(budgetId: string, scheduledTransactionId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ScheduledTransactionResponse>>;
    getScheduledTransactionById(budgetId: string, scheduledTransactionId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ScheduledTransactionResponse>>;
    /**
     * List scheduled transactions
     * Returns all scheduled transactions
     * @param budgetId The id of the budget (\&quot;last-used\&quot; can also be used to specify the last used budget)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getScheduledTransactions(budgetId: string, observe?: 'body', reportProgress?: boolean): Observable<ScheduledTransactionsResponse>;
    getScheduledTransactions(budgetId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ScheduledTransactionsResponse>>;
    getScheduledTransactions(budgetId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ScheduledTransactionsResponse>>;
}
