(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('@lwoerdeman/typescript-angular-ynab', ['exports', '@angular/core', '@angular/common/http'], factory) :
    (global = global || self, factory((global.lwoerdeman = global.lwoerdeman || {}, global.lwoerdeman['typescript-angular-ynab'] = {}), global.ng.core, global.ng.common.http));
}(this, function (exports, core, http) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
    * CustomHttpUrlEncodingCodec
    * Fix plus sign (+) not encoding, so sent as blank space
    * See: https://github.com/angular/angular/issues/11058#issuecomment-247367318
    */
    var CustomHttpUrlEncodingCodec = /** @class */ (function (_super) {
        __extends(CustomHttpUrlEncodingCodec, _super);
        function CustomHttpUrlEncodingCodec() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CustomHttpUrlEncodingCodec.prototype.encodeKey = function (k) {
            k = _super.prototype.encodeKey.call(this, k);
            return k.replace(/\+/gi, '%2B');
        };
        CustomHttpUrlEncodingCodec.prototype.encodeValue = function (v) {
            v = _super.prototype.encodeValue.call(this, v);
            return v.replace(/\+/gi, '%2B');
        };
        return CustomHttpUrlEncodingCodec;
    }(http.HttpUrlEncodingCodec));

    var BASE_PATH = new core.InjectionToken('basePath');
    var COLLECTION_FORMATS = {
        'csv': ',',
        'tsv': '   ',
        'ssv': ' ',
        'pipes': '|'
    };

    var Configuration = /** @class */ (function () {
        function Configuration(configurationParameters) {
            if (configurationParameters === void 0) { configurationParameters = {}; }
            this.apiKeys = configurationParameters.apiKeys;
            this.username = configurationParameters.username;
            this.password = configurationParameters.password;
            this.accessToken = configurationParameters.accessToken;
            this.basePath = configurationParameters.basePath;
            this.withCredentials = configurationParameters.withCredentials;
        }
        /**
         * Select the correct content-type to use for a request.
         * Uses {@link Configuration#isJsonMime} to determine the correct content-type.
         * If no content type is found return the first found type if the contentTypes is not empty
         * @param contentTypes - the array of content types that are available for selection
         * @returns the selected content-type or <code>undefined</code> if no selection could be made.
         */
        Configuration.prototype.selectHeaderContentType = function (contentTypes) {
            var _this = this;
            if (contentTypes.length === 0) {
                return undefined;
            }
            var type = contentTypes.find(function (x) { return _this.isJsonMime(x); });
            if (type === undefined) {
                return contentTypes[0];
            }
            return type;
        };
        /**
         * Select the correct accept content-type to use for a request.
         * Uses {@link Configuration#isJsonMime} to determine the correct accept content-type.
         * If no content type is found return the first found type if the contentTypes is not empty
         * @param accepts - the array of content types that are available for selection.
         * @returns the selected content-type or <code>undefined</code> if no selection could be made.
         */
        Configuration.prototype.selectHeaderAccept = function (accepts) {
            var _this = this;
            if (accepts.length === 0) {
                return undefined;
            }
            var type = accepts.find(function (x) { return _this.isJsonMime(x); });
            if (type === undefined) {
                return accepts[0];
            }
            return type;
        };
        /**
         * Check if the given MIME is a JSON MIME.
         * JSON MIME examples:
         *   application/json
         *   application/json; charset=UTF8
         *   APPLICATION/JSON
         *   application/vnd.company+json
         * @param mime - MIME (Multipurpose Internet Mail Extensions)
         * @return True if the given MIME is JSON, false otherwise.
         */
        Configuration.prototype.isJsonMime = function (mime) {
            var jsonMime = new RegExp('^(application\/json|[^;/ \t]+\/[^;/ \t]+[+]json)[ \t]*(;.*)?$', 'i');
            return mime !== null && (jsonMime.test(mime) || mime.toLowerCase() === 'application/json-patch+json');
        };
        return Configuration;
    }());

    var AccountsService = /** @class */ (function () {
        function AccountsService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        AccountsService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        AccountsService.prototype.getAccountById = function (budgetId, accountId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getAccountById.');
            }
            if (accountId === null || accountId === undefined) {
                throw new Error('Required parameter accountId was null or undefined when calling getAccountById.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/accounts/" + encodeURIComponent(String(accountId)), {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        AccountsService.prototype.getAccounts = function (budgetId, lastKnowledgeOfServer, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getAccounts.');
            }
            var queryParameters = new http.HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
            if (lastKnowledgeOfServer !== undefined && lastKnowledgeOfServer !== null) {
                queryParameters = queryParameters.set('last_knowledge_of_server', lastKnowledgeOfServer);
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/accounts", {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        AccountsService.ngInjectableDef = core.defineInjectable({ factory: function AccountsService_Factory() { return new AccountsService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: AccountsService, providedIn: "root" });
        AccountsService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], AccountsService);
        return AccountsService;
    }());

    var BudgetsService = /** @class */ (function () {
        function BudgetsService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        BudgetsService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        BudgetsService.prototype.getBudgetById = function (budgetId, lastKnowledgeOfServer, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getBudgetById.');
            }
            var queryParameters = new http.HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
            if (lastKnowledgeOfServer !== undefined && lastKnowledgeOfServer !== null) {
                queryParameters = queryParameters.set('last_knowledge_of_server', lastKnowledgeOfServer);
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)), {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        BudgetsService.prototype.getBudgetSettingsById = function (budgetId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getBudgetSettingsById.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/settings", {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        BudgetsService.prototype.getBudgets = function (observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets", {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        BudgetsService.ngInjectableDef = core.defineInjectable({ factory: function BudgetsService_Factory() { return new BudgetsService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: BudgetsService, providedIn: "root" });
        BudgetsService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], BudgetsService);
        return BudgetsService;
    }());

    var CategoriesService = /** @class */ (function () {
        function CategoriesService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        CategoriesService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        CategoriesService.prototype.getCategories = function (budgetId, lastKnowledgeOfServer, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getCategories.');
            }
            var queryParameters = new http.HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
            if (lastKnowledgeOfServer !== undefined && lastKnowledgeOfServer !== null) {
                queryParameters = queryParameters.set('last_knowledge_of_server', lastKnowledgeOfServer);
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/categories", {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        CategoriesService.prototype.getCategoryById = function (budgetId, categoryId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getCategoryById.');
            }
            if (categoryId === null || categoryId === undefined) {
                throw new Error('Required parameter categoryId was null or undefined when calling getCategoryById.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/categories/" + encodeURIComponent(String(categoryId)), {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        CategoriesService.prototype.getMonthCategoryById = function (budgetId, month, categoryId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getMonthCategoryById.');
            }
            if (month === null || month === undefined) {
                throw new Error('Required parameter month was null or undefined when calling getMonthCategoryById.');
            }
            if (categoryId === null || categoryId === undefined) {
                throw new Error('Required parameter categoryId was null or undefined when calling getMonthCategoryById.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/months/" + encodeURIComponent(String(month)) + "/categories/" + encodeURIComponent(String(categoryId)), {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        CategoriesService.prototype.updateMonthCategory = function (budgetId, month, categoryId, data, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling updateMonthCategory.');
            }
            if (month === null || month === undefined) {
                throw new Error('Required parameter month was null or undefined when calling updateMonthCategory.');
            }
            if (categoryId === null || categoryId === undefined) {
                throw new Error('Required parameter categoryId was null or undefined when calling updateMonthCategory.');
            }
            if (data === null || data === undefined) {
                throw new Error('Required parameter data was null or undefined when calling updateMonthCategory.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            // to determine the Content-Type header
            var consumes = [];
            var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
            if (httpContentTypeSelected !== undefined) {
                headers = headers.set('Content-Type', httpContentTypeSelected);
            }
            return this.httpClient.patch(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/months/" + encodeURIComponent(String(month)) + "/categories/" + encodeURIComponent(String(categoryId)), data, {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        CategoriesService.ngInjectableDef = core.defineInjectable({ factory: function CategoriesService_Factory() { return new CategoriesService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: CategoriesService, providedIn: "root" });
        CategoriesService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], CategoriesService);
        return CategoriesService;
    }());

    var DeprecatedService = /** @class */ (function () {
        function DeprecatedService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        DeprecatedService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        DeprecatedService.prototype.bulkCreateTransactions = function (budgetId, transactions, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling bulkCreateTransactions.');
            }
            if (transactions === null || transactions === undefined) {
                throw new Error('Required parameter transactions was null or undefined when calling bulkCreateTransactions.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            // to determine the Content-Type header
            var consumes = [];
            var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
            if (httpContentTypeSelected !== undefined) {
                headers = headers.set('Content-Type', httpContentTypeSelected);
            }
            return this.httpClient.post(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/transactions/bulk", transactions, {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        DeprecatedService.ngInjectableDef = core.defineInjectable({ factory: function DeprecatedService_Factory() { return new DeprecatedService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: DeprecatedService, providedIn: "root" });
        DeprecatedService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], DeprecatedService);
        return DeprecatedService;
    }());

    var MonthsService = /** @class */ (function () {
        function MonthsService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        MonthsService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        MonthsService.prototype.getBudgetMonth = function (budgetId, month, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getBudgetMonth.');
            }
            if (month === null || month === undefined) {
                throw new Error('Required parameter month was null or undefined when calling getBudgetMonth.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/months/" + encodeURIComponent(String(month)), {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        MonthsService.prototype.getBudgetMonths = function (budgetId, lastKnowledgeOfServer, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getBudgetMonths.');
            }
            var queryParameters = new http.HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
            if (lastKnowledgeOfServer !== undefined && lastKnowledgeOfServer !== null) {
                queryParameters = queryParameters.set('last_knowledge_of_server', lastKnowledgeOfServer);
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/months", {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        MonthsService.ngInjectableDef = core.defineInjectable({ factory: function MonthsService_Factory() { return new MonthsService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: MonthsService, providedIn: "root" });
        MonthsService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], MonthsService);
        return MonthsService;
    }());

    var PayeeLocationsService = /** @class */ (function () {
        function PayeeLocationsService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        PayeeLocationsService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        PayeeLocationsService.prototype.getPayeeLocationById = function (budgetId, payeeLocationId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getPayeeLocationById.');
            }
            if (payeeLocationId === null || payeeLocationId === undefined) {
                throw new Error('Required parameter payeeLocationId was null or undefined when calling getPayeeLocationById.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/payee_locations/" + encodeURIComponent(String(payeeLocationId)), {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        PayeeLocationsService.prototype.getPayeeLocations = function (budgetId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getPayeeLocations.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/payee_locations", {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        PayeeLocationsService.prototype.getPayeeLocationsByPayee = function (budgetId, payeeId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getPayeeLocationsByPayee.');
            }
            if (payeeId === null || payeeId === undefined) {
                throw new Error('Required parameter payeeId was null or undefined when calling getPayeeLocationsByPayee.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/payees/" + encodeURIComponent(String(payeeId)) + "/payee_locations", {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        PayeeLocationsService.ngInjectableDef = core.defineInjectable({ factory: function PayeeLocationsService_Factory() { return new PayeeLocationsService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: PayeeLocationsService, providedIn: "root" });
        PayeeLocationsService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], PayeeLocationsService);
        return PayeeLocationsService;
    }());

    var PayeesService = /** @class */ (function () {
        function PayeesService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        PayeesService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        PayeesService.prototype.getPayeeById = function (budgetId, payeeId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getPayeeById.');
            }
            if (payeeId === null || payeeId === undefined) {
                throw new Error('Required parameter payeeId was null or undefined when calling getPayeeById.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/payees/" + encodeURIComponent(String(payeeId)), {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        PayeesService.prototype.getPayees = function (budgetId, lastKnowledgeOfServer, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getPayees.');
            }
            var queryParameters = new http.HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
            if (lastKnowledgeOfServer !== undefined && lastKnowledgeOfServer !== null) {
                queryParameters = queryParameters.set('last_knowledge_of_server', lastKnowledgeOfServer);
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/payees", {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        PayeesService.ngInjectableDef = core.defineInjectable({ factory: function PayeesService_Factory() { return new PayeesService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: PayeesService, providedIn: "root" });
        PayeesService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], PayeesService);
        return PayeesService;
    }());

    var ScheduledTransactionsService = /** @class */ (function () {
        function ScheduledTransactionsService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        ScheduledTransactionsService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        ScheduledTransactionsService.prototype.getScheduledTransactionById = function (budgetId, scheduledTransactionId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getScheduledTransactionById.');
            }
            if (scheduledTransactionId === null || scheduledTransactionId === undefined) {
                throw new Error('Required parameter scheduledTransactionId was null or undefined when calling getScheduledTransactionById.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/scheduled_transactions/" + encodeURIComponent(String(scheduledTransactionId)), {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        ScheduledTransactionsService.prototype.getScheduledTransactions = function (budgetId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getScheduledTransactions.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/scheduled_transactions", {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        ScheduledTransactionsService.ngInjectableDef = core.defineInjectable({ factory: function ScheduledTransactionsService_Factory() { return new ScheduledTransactionsService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: ScheduledTransactionsService, providedIn: "root" });
        ScheduledTransactionsService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], ScheduledTransactionsService);
        return ScheduledTransactionsService;
    }());

    var TransactionsService = /** @class */ (function () {
        function TransactionsService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        TransactionsService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        TransactionsService.prototype.createTransaction = function (budgetId, data, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling createTransaction.');
            }
            if (data === null || data === undefined) {
                throw new Error('Required parameter data was null or undefined when calling createTransaction.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            // to determine the Content-Type header
            var consumes = [];
            var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
            if (httpContentTypeSelected !== undefined) {
                headers = headers.set('Content-Type', httpContentTypeSelected);
            }
            return this.httpClient.post(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/transactions", data, {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        TransactionsService.prototype.getTransactionById = function (budgetId, transactionId, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getTransactionById.');
            }
            if (transactionId === null || transactionId === undefined) {
                throw new Error('Required parameter transactionId was null or undefined when calling getTransactionById.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/transactions/" + encodeURIComponent(String(transactionId)), {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        TransactionsService.prototype.getTransactions = function (budgetId, sinceDate, type, lastKnowledgeOfServer, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getTransactions.');
            }
            var queryParameters = new http.HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
            if (sinceDate !== undefined && sinceDate !== null) {
                queryParameters = queryParameters.set('since_date', sinceDate);
            }
            if (type !== undefined && type !== null) {
                queryParameters = queryParameters.set('type', type);
            }
            if (lastKnowledgeOfServer !== undefined && lastKnowledgeOfServer !== null) {
                queryParameters = queryParameters.set('last_knowledge_of_server', lastKnowledgeOfServer);
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/transactions", {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        TransactionsService.prototype.getTransactionsByAccount = function (budgetId, accountId, sinceDate, type, lastKnowledgeOfServer, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getTransactionsByAccount.');
            }
            if (accountId === null || accountId === undefined) {
                throw new Error('Required parameter accountId was null or undefined when calling getTransactionsByAccount.');
            }
            var queryParameters = new http.HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
            if (sinceDate !== undefined && sinceDate !== null) {
                queryParameters = queryParameters.set('since_date', sinceDate);
            }
            if (type !== undefined && type !== null) {
                queryParameters = queryParameters.set('type', type);
            }
            if (lastKnowledgeOfServer !== undefined && lastKnowledgeOfServer !== null) {
                queryParameters = queryParameters.set('last_knowledge_of_server', lastKnowledgeOfServer);
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/accounts/" + encodeURIComponent(String(accountId)) + "/transactions", {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        TransactionsService.prototype.getTransactionsByCategory = function (budgetId, categoryId, sinceDate, type, lastKnowledgeOfServer, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getTransactionsByCategory.');
            }
            if (categoryId === null || categoryId === undefined) {
                throw new Error('Required parameter categoryId was null or undefined when calling getTransactionsByCategory.');
            }
            var queryParameters = new http.HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
            if (sinceDate !== undefined && sinceDate !== null) {
                queryParameters = queryParameters.set('since_date', sinceDate);
            }
            if (type !== undefined && type !== null) {
                queryParameters = queryParameters.set('type', type);
            }
            if (lastKnowledgeOfServer !== undefined && lastKnowledgeOfServer !== null) {
                queryParameters = queryParameters.set('last_knowledge_of_server', lastKnowledgeOfServer);
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/categories/" + encodeURIComponent(String(categoryId)) + "/transactions", {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        TransactionsService.prototype.getTransactionsByPayee = function (budgetId, payeeId, sinceDate, type, lastKnowledgeOfServer, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling getTransactionsByPayee.');
            }
            if (payeeId === null || payeeId === undefined) {
                throw new Error('Required parameter payeeId was null or undefined when calling getTransactionsByPayee.');
            }
            var queryParameters = new http.HttpParams({ encoder: new CustomHttpUrlEncodingCodec() });
            if (sinceDate !== undefined && sinceDate !== null) {
                queryParameters = queryParameters.set('since_date', sinceDate);
            }
            if (type !== undefined && type !== null) {
                queryParameters = queryParameters.set('type', type);
            }
            if (lastKnowledgeOfServer !== undefined && lastKnowledgeOfServer !== null) {
                queryParameters = queryParameters.set('last_knowledge_of_server', lastKnowledgeOfServer);
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/payees/" + encodeURIComponent(String(payeeId)) + "/transactions", {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        TransactionsService.prototype.updateTransaction = function (budgetId, transactionId, data, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling updateTransaction.');
            }
            if (transactionId === null || transactionId === undefined) {
                throw new Error('Required parameter transactionId was null or undefined when calling updateTransaction.');
            }
            if (data === null || data === undefined) {
                throw new Error('Required parameter data was null or undefined when calling updateTransaction.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            // to determine the Content-Type header
            var consumes = [];
            var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
            if (httpContentTypeSelected !== undefined) {
                headers = headers.set('Content-Type', httpContentTypeSelected);
            }
            return this.httpClient.put(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/transactions/" + encodeURIComponent(String(transactionId)), data, {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        TransactionsService.prototype.updateTransactions = function (budgetId, data, observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            if (budgetId === null || budgetId === undefined) {
                throw new Error('Required parameter budgetId was null or undefined when calling updateTransactions.');
            }
            if (data === null || data === undefined) {
                throw new Error('Required parameter data was null or undefined when calling updateTransactions.');
            }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            // to determine the Content-Type header
            var consumes = [];
            var httpContentTypeSelected = this.configuration.selectHeaderContentType(consumes);
            if (httpContentTypeSelected !== undefined) {
                headers = headers.set('Content-Type', httpContentTypeSelected);
            }
            return this.httpClient.patch(this.configuration.basePath + "/budgets/" + encodeURIComponent(String(budgetId)) + "/transactions", data, {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        TransactionsService.ngInjectableDef = core.defineInjectable({ factory: function TransactionsService_Factory() { return new TransactionsService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: TransactionsService, providedIn: "root" });
        TransactionsService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], TransactionsService);
        return TransactionsService;
    }());

    var UserService = /** @class */ (function () {
        function UserService(httpClient, basePath, configuration) {
            this.httpClient = httpClient;
            this.basePath = 'https://api.youneedabudget.com/v1';
            this.defaultHeaders = new http.HttpHeaders();
            this.configuration = new Configuration();
            if (configuration) {
                this.configuration = configuration;
                this.configuration.basePath = configuration.basePath || basePath || this.basePath;
            }
            else {
                this.configuration.basePath = basePath || this.basePath;
            }
        }
        /**
         * @param consumes string[] mime-types
         * @return true: consumes contains 'multipart/form-data', false: otherwise
         */
        UserService.prototype.canConsumeForm = function (consumes) {
            var e_1, _a;
            var form = 'multipart/form-data';
            try {
                for (var consumes_1 = __values(consumes), consumes_1_1 = consumes_1.next(); !consumes_1_1.done; consumes_1_1 = consumes_1.next()) {
                    var consume = consumes_1_1.value;
                    if (form === consume) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (consumes_1_1 && !consumes_1_1.done && (_a = consumes_1.return)) _a.call(consumes_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        };
        UserService.prototype.getUser = function (observe, reportProgress) {
            if (observe === void 0) { observe = 'body'; }
            if (reportProgress === void 0) { reportProgress = false; }
            var headers = this.defaultHeaders;
            // authentication (bearer) required
            if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
                headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
            }
            // to determine the Accept header
            var httpHeaderAccepts = [
                'application/json'
            ];
            var httpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
            if (httpHeaderAcceptSelected !== undefined) {
                headers = headers.set('Accept', httpHeaderAcceptSelected);
            }
            return this.httpClient.get(this.configuration.basePath + "/user", {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            });
        };
        UserService.ngInjectableDef = core.defineInjectable({ factory: function UserService_Factory() { return new UserService(core.inject(http.HttpClient), core.inject(BASE_PATH, 8), core.inject(Configuration, 8)); }, token: UserService, providedIn: "root" });
        UserService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Optional()), __param(1, core.Inject(BASE_PATH)), __param(2, core.Optional()),
            __metadata("design:paramtypes", [http.HttpClient, String, Configuration])
        ], UserService);
        return UserService;
    }());

    var APIS = [AccountsService, BudgetsService, CategoriesService, DeprecatedService, MonthsService, PayeeLocationsService, PayeesService, ScheduledTransactionsService, TransactionsService, UserService];

    /**
     * YNAB API Endpoints
     * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
     *
     * OpenAPI spec version: 1.0.0
     *
     *
     * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
     * https://openapi-generator.tech
     * Do not edit the class manually.
     */

    (function (Account) {
        Account.TypeEnum = {
            Checking: 'checking',
            Savings: 'savings',
            Cash: 'cash',
            CreditCard: 'creditCard',
            LineOfCredit: 'lineOfCredit',
            OtherAsset: 'otherAsset',
            OtherLiability: 'otherLiability',
            PayPal: 'payPal',
            MerchantAccount: 'merchantAccount',
            InvestmentAccount: 'investmentAccount',
            Mortgage: 'mortgage'
        };
    })(exports.Account || (exports.Account = {}));

    /**
     * YNAB API Endpoints
     * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
     *
     * OpenAPI spec version: 1.0.0
     *
     *
     * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
     * https://openapi-generator.tech
     * Do not edit the class manually.
     */

    (function (Category) {
        Category.GoalTypeEnum = {
            TB: 'TB',
            TBD: 'TBD',
            MF: 'MF'
        };
    })(exports.Category || (exports.Category = {}));


    (function (HybridTransaction) {
        HybridTransaction.ClearedEnum = {
            Cleared: 'cleared',
            Uncleared: 'uncleared',
            Reconciled: 'reconciled'
        };
        HybridTransaction.FlagColorEnum = {
            Red: 'red',
            Orange: 'orange',
            Yellow: 'yellow',
            Green: 'green',
            Blue: 'blue',
            Purple: 'purple'
        };
        HybridTransaction.TypeEnum = {
            Transaction: 'transaction',
            Subtransaction: 'subtransaction'
        };
    })(exports.HybridTransaction || (exports.HybridTransaction = {}));

    /**
     * YNAB API Endpoints
     * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
     *
     * OpenAPI spec version: 1.0.0
     *
     *
     * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
     * https://openapi-generator.tech
     * Do not edit the class manually.
     */

    (function (SaveTransaction) {
        SaveTransaction.ClearedEnum = {
            Cleared: 'cleared',
            Uncleared: 'uncleared',
            Reconciled: 'reconciled'
        };
        SaveTransaction.FlagColorEnum = {
            Red: 'red',
            Orange: 'orange',
            Yellow: 'yellow',
            Green: 'green',
            Blue: 'blue',
            Purple: 'purple'
        };
    })(exports.SaveTransaction || (exports.SaveTransaction = {}));


    (function (ScheduledTransactionDetail) {
        ScheduledTransactionDetail.FrequencyEnum = {
            Never: 'never',
            Daily: 'daily',
            Weekly: 'weekly',
            EveryOtherWeek: 'everyOtherWeek',
            TwiceAMonth: 'twiceAMonth',
            Every4Weeks: 'every4Weeks',
            Monthly: 'monthly',
            EveryOtherMonth: 'everyOtherMonth',
            Every3Months: 'every3Months',
            Every4Months: 'every4Months',
            TwiceAYear: 'twiceAYear',
            Yearly: 'yearly',
            EveryOtherYear: 'everyOtherYear'
        };
        ScheduledTransactionDetail.FlagColorEnum = {
            Red: 'red',
            Orange: 'orange',
            Yellow: 'yellow',
            Green: 'green',
            Blue: 'blue',
            Purple: 'purple'
        };
    })(exports.ScheduledTransactionDetail || (exports.ScheduledTransactionDetail = {}));

    /**
     * YNAB API Endpoints
     * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
     *
     * OpenAPI spec version: 1.0.0
     *
     *
     * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
     * https://openapi-generator.tech
     * Do not edit the class manually.
     */

    (function (ScheduledTransactionSummary) {
        ScheduledTransactionSummary.FrequencyEnum = {
            Never: 'never',
            Daily: 'daily',
            Weekly: 'weekly',
            EveryOtherWeek: 'everyOtherWeek',
            TwiceAMonth: 'twiceAMonth',
            Every4Weeks: 'every4Weeks',
            Monthly: 'monthly',
            EveryOtherMonth: 'everyOtherMonth',
            Every3Months: 'every3Months',
            Every4Months: 'every4Months',
            TwiceAYear: 'twiceAYear',
            Yearly: 'yearly',
            EveryOtherYear: 'everyOtherYear'
        };
        ScheduledTransactionSummary.FlagColorEnum = {
            Red: 'red',
            Orange: 'orange',
            Yellow: 'yellow',
            Green: 'green',
            Blue: 'blue',
            Purple: 'purple'
        };
    })(exports.ScheduledTransactionSummary || (exports.ScheduledTransactionSummary = {}));


    (function (TransactionDetail) {
        TransactionDetail.ClearedEnum = {
            Cleared: 'cleared',
            Uncleared: 'uncleared',
            Reconciled: 'reconciled'
        };
        TransactionDetail.FlagColorEnum = {
            Red: 'red',
            Orange: 'orange',
            Yellow: 'yellow',
            Green: 'green',
            Blue: 'blue',
            Purple: 'purple'
        };
    })(exports.TransactionDetail || (exports.TransactionDetail = {}));

    /**
     * YNAB API Endpoints
     * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
     *
     * OpenAPI spec version: 1.0.0
     *
     *
     * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
     * https://openapi-generator.tech
     * Do not edit the class manually.
     */

    (function (TransactionSummary) {
        TransactionSummary.ClearedEnum = {
            Cleared: 'cleared',
            Uncleared: 'uncleared',
            Reconciled: 'reconciled'
        };
        TransactionSummary.FlagColorEnum = {
            Red: 'red',
            Orange: 'orange',
            Yellow: 'yellow',
            Green: 'green',
            Blue: 'blue',
            Purple: 'purple'
        };
    })(exports.TransactionSummary || (exports.TransactionSummary = {}));

    var ApiModule = /** @class */ (function () {
        function ApiModule(parentModule, http) {
            if (parentModule) {
                throw new Error('ApiModule is already loaded. Import in your base AppModule only.');
            }
            if (!http) {
                throw new Error('You need to import the HttpClientModule in your AppModule! \n' +
                    'See also https://github.com/angular/angular/issues/20575');
            }
        }
        ApiModule_1 = ApiModule;
        ApiModule.forRoot = function (configurationFactory) {
            return {
                ngModule: ApiModule_1,
                providers: [{ provide: Configuration, useFactory: configurationFactory }]
            };
        };
        var ApiModule_1;
        ApiModule = ApiModule_1 = __decorate([
            core.NgModule({
                imports: [],
                declarations: [],
                exports: [],
                providers: [
                    AccountsService,
                    BudgetsService,
                    CategoriesService,
                    DeprecatedService,
                    MonthsService,
                    PayeeLocationsService,
                    PayeesService,
                    ScheduledTransactionsService,
                    TransactionsService,
                    UserService
                ]
            }),
            __param(0, core.Optional()), __param(0, core.SkipSelf()),
            __param(1, core.Optional()),
            __metadata("design:paramtypes", [ApiModule,
                http.HttpClient])
        ], ApiModule);
        return ApiModule;
    }());

    exports.APIS = APIS;
    exports.AccountsService = AccountsService;
    exports.ApiModule = ApiModule;
    exports.BASE_PATH = BASE_PATH;
    exports.BudgetsService = BudgetsService;
    exports.COLLECTION_FORMATS = COLLECTION_FORMATS;
    exports.CategoriesService = CategoriesService;
    exports.Configuration = Configuration;
    exports.DeprecatedService = DeprecatedService;
    exports.MonthsService = MonthsService;
    exports.PayeeLocationsService = PayeeLocationsService;
    exports.PayeesService = PayeesService;
    exports.ScheduledTransactionsService = ScheduledTransactionsService;
    exports.TransactionsService = TransactionsService;
    exports.UserService = UserService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lwoerdeman-typescript-angular-ynab.umd.js.map
