/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
export interface Account {
    id: string;
    name: string;
    /**
     * The type of account. Note: payPal, merchantAccount, investmentAccount, and mortgage types have been deprecated and will be removed in the future.
     */
    type: Account.TypeEnum;
    /**
     * Whether this account is on budget or not
     */
    onBudget: boolean;
    /**
     * Whether this account is closed or not
     */
    closed: boolean;
    note: string;
    /**
     * The current balance of the account in milliunits format
     */
    balance: number;
    /**
     * The current cleared balance of the account in milliunits format
     */
    clearedBalance: number;
    /**
     * The current uncleared balance of the account in milliunits format
     */
    unclearedBalance: number;
    /**
     * The payee id which should be used when transferring to this account
     */
    transferPayeeId: string;
    /**
     * Whether or not the account has been deleted.  Deleted accounts will only be included in delta requests.
     */
    deleted: boolean;
}
export declare namespace Account {
    type TypeEnum = 'checking' | 'savings' | 'cash' | 'creditCard' | 'lineOfCredit' | 'otherAsset' | 'otherLiability' | 'payPal' | 'merchantAccount' | 'investmentAccount' | 'mortgage';
    const TypeEnum: {
        Checking: TypeEnum;
        Savings: TypeEnum;
        Cash: TypeEnum;
        CreditCard: TypeEnum;
        LineOfCredit: TypeEnum;
        OtherAsset: TypeEnum;
        OtherLiability: TypeEnum;
        PayPal: TypeEnum;
        MerchantAccount: TypeEnum;
        InvestmentAccount: TypeEnum;
        Mortgage: TypeEnum;
    };
}
