/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { Account } from './account';
import { Category } from './category';
import { CategoryGroup } from './categoryGroup';
import { CurrencyFormat } from './currencyFormat';
import { DateFormat } from './dateFormat';
import { MonthDetail } from './monthDetail';
import { Payee } from './payee';
import { PayeeLocation } from './payeeLocation';
import { ScheduledSubTransaction } from './scheduledSubTransaction';
import { ScheduledTransactionSummary } from './scheduledTransactionSummary';
import { SubTransaction } from './subTransaction';
import { TransactionSummary } from './transactionSummary';
export interface BudgetDetail {
    id: string;
    name: string;
    /**
     * The last time any changes were made to the budget from either a web or mobile client.
     */
    lastModifiedOn?: Date;
    /**
     * The earliest budget month.
     */
    firstMonth?: string;
    /**
     * The latest budget month.
     */
    lastMonth?: string;
    dateFormat?: DateFormat;
    currencyFormat?: CurrencyFormat;
    accounts?: Array<Account>;
    payees?: Array<Payee>;
    payeeLocations?: Array<PayeeLocation>;
    categoryGroups?: Array<CategoryGroup>;
    categories?: Array<Category>;
    months?: Array<MonthDetail>;
    transactions?: Array<TransactionSummary>;
    subtransactions?: Array<SubTransaction>;
    scheduledTransactions?: Array<ScheduledTransactionSummary>;
    scheduledSubtransactions?: Array<ScheduledSubTransaction>;
}
