/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
export interface MonthSummary {
    month: string;
    note: string;
    /**
     * The total amount in transactions categorized to \'Inflow: To be Budgeted\' in the month
     */
    income: number;
    /**
     * The total amount budgeted in the month
     */
    budgeted: number;
    /**
     * The total amount in transactions in the month, excluding those categorized to \'Inflow: To be Budgeted\'
     */
    activity: number;
    /**
     * The available amount for \'To be Budgeted\'
     */
    toBeBudgeted: number;
    /**
     * The Age of Money as of the month
     */
    ageOfMoney: number;
    /**
     * Whether or not the month has been deleted.  Deleted months will only be included in delta requests.
     */
    deleted: boolean;
}
