/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
export interface ScheduledTransactionSummary {
    id: string;
    /**
     * The first date for which the Scheduled Transaction was scheduled.
     */
    dateFirst: string;
    /**
     * The next date for which the Scheduled Transaction is scheduled.
     */
    dateNext: string;
    frequency: ScheduledTransactionSummary.FrequencyEnum;
    /**
     * The scheduled transaction amount in milliunits format
     */
    amount: number;
    memo: string;
    /**
     * The scheduled transaction flag
     */
    flagColor: ScheduledTransactionSummary.FlagColorEnum;
    accountId: string;
    payeeId: string;
    categoryId: string;
    /**
     * If a transfer, the account_id which the scheduled transaction transfers to
     */
    transferAccountId: string;
    /**
     * Whether or not the scheduled transaction has been deleted.  Deleted scheduled transactions will only be included in delta requests.
     */
    deleted: boolean;
}
export declare namespace ScheduledTransactionSummary {
    type FrequencyEnum = 'never' | 'daily' | 'weekly' | 'everyOtherWeek' | 'twiceAMonth' | 'every4Weeks' | 'monthly' | 'everyOtherMonth' | 'every3Months' | 'every4Months' | 'twiceAYear' | 'yearly' | 'everyOtherYear';
    const FrequencyEnum: {
        Never: FrequencyEnum;
        Daily: FrequencyEnum;
        Weekly: FrequencyEnum;
        EveryOtherWeek: FrequencyEnum;
        TwiceAMonth: FrequencyEnum;
        Every4Weeks: FrequencyEnum;
        Monthly: FrequencyEnum;
        EveryOtherMonth: FrequencyEnum;
        Every3Months: FrequencyEnum;
        Every4Months: FrequencyEnum;
        TwiceAYear: FrequencyEnum;
        Yearly: FrequencyEnum;
        EveryOtherYear: FrequencyEnum;
    };
    type FlagColorEnum = 'red' | 'orange' | 'yellow' | 'green' | 'blue' | 'purple';
    const FlagColorEnum: {
        Red: FlagColorEnum;
        Orange: FlagColorEnum;
        Yellow: FlagColorEnum;
        Green: FlagColorEnum;
        Blue: FlagColorEnum;
        Purple: FlagColorEnum;
    };
}
